function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Theme = function () {
  function Theme(themesObj, defaultTheme) {
    _classCallCheck(this, Theme);

    this.themesObj = themesObj;
    this.activeTheme = this.themesObj[defaultTheme];
    // list of callbacks to execute when the theme is changed
    this.subscriptions = [];
  }

  Theme.prototype.setTheme = function setTheme(newTheme) {
    this.activeTheme = this.themesObj[newTheme];
    // make sure all of the subscribed components get notified of theme change
    this.subscriptions.forEach(function (cb) {
      return cb();
    });
  };

  Theme.prototype.subscribe = function subscribe(cb) {
    this.subscriptions.push(cb);
  };

  return Theme;
}();

export { Theme as default };