var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component, PropTypes as t } from 'react';
import Theme from './Theme';
import { getDisplayName } from './utils';

var injectThemes = function injectThemes(themesObj, defaultTheme) {
  return function (WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(InjectThemes, _Component);

      function InjectThemes(props, context) {
        _classCallCheck(this, InjectThemes);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        _this.changeTheme = function (theme) {
          _this.setState(function () {
            return {
              activeTheme: theme
            };
          });
        };

        _this.theme = new Theme(themesObj, defaultTheme);

        _this.state = {
          activeTheme: defaultTheme
        };
        return _this;
      }

      InjectThemes.prototype.componentWillUpdate = function componentWillUpdate(nextProps, nextState) {
        this.theme.setTheme(nextState.activeTheme);
      };

      InjectThemes.prototype.getChildContext = function getChildContext() {
        return { theme: this.theme };
      };

      InjectThemes.prototype.render = function render() {
        return React.createElement(WrappedComponent, _extends({}, this.props, {
          activeTheme: this.state.activeTheme,
          changeTheme: this.changeTheme
        }));
      };

      return InjectThemes;
    }(Component), _class.displayName = 'InjectThemes(' + getDisplayName(WrappedComponent) + ')', _class.childContextTypes = {
      theme: t.object.isRequired
    }, _temp;
  };
};

export default injectThemes;