var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component, PropTypes as t } from 'react';
import { getDisplayName } from './utils';

function withTheme(WrappedComponent) {
  var _class, _temp;

  return _temp = _class = function (_Component) {
    _inherits(WithTheme, _Component);

    function WithTheme() {
      _classCallCheck(this, WithTheme);

      return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    WithTheme.prototype.componentDidMount = function componentDidMount() {
      var _this2 = this;

      /* pass a callback to the subscriptions.
      this lets the themes know which components need to be updated.
      this particular callback will cause the component
      to update when the theme is changed.*/
      this.context.theme.subscribe(function () {
        return _this2.forceUpdate();
      });
    };

    WithTheme.prototype.render = function render() {
      return React.createElement(WrappedComponent, _extends({}, this.props, {
        theme: this.context.theme.activeTheme
      }));
    };

    return WithTheme;
  }(Component), _class.displayName = 'InjectThemes(' + getDisplayName(WrappedComponent) + ')', _class.contextTypes = {
    theme: t.object
  }, _temp;
}

export default withTheme;